/**
 * gmp-interface.h
 *
 * Copyright (c) 2001 Regents of the University of California.
 * All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *  3. Neither the name of the University nor the names of its contributors
 *     may be used to endorse or promote products derived from this software
 *     without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 *  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 *  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 *  ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 *  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 *  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 *  OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 *  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 *  OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 *  SUCH DAMAGE.
 */

#include <jni.h>
#include <gmp.h>
#include <openssl/evp.h>

extern size_t
mpz_out_raw (unsigned char **out_bytes, unsigned int *out_len, mpz_srcptr x);
extern void mpz2mag (mpz_t v, unsigned char **bytes, unsigned int *len);
extern size_t
mpz_inp_raw (mpz_ptr x, unsigned char *in_bytes, mp_size_t in_bytesize);
extern void mag2mpz (mpz_t rop, unsigned char *bytes, unsigned int len);
extern void bigint2mpz (mpz_t rop,
	JNIEnv *env, jobject x, jmethodID big_int_to_byte_array);
extern jobject mpz2bigint (
	JNIEnv *env, mpz_t x, jclass
	big_int_class, jmethodID big_int_init);
extern void print_mpz (const char *name, mpz_t op);
extern void add_to_hash (EVP_MD_CTX *md, mpz_t value, jboolean debug);


