/**
 * TMessageEvent
 *
 * @author     Ben Y. Zhao
 * @version    $Id: TMessageEvent.java,v 1.7 2002/07/22 20:54:53 srhea Exp $
 */

package ostore.tapestry;
import ostore.util.*;
import seda.sandStorm.api.*;

/****************
 ** Superclass for all Tapestry Message Events
 **/
public abstract class TMessageEvent 
implements TEventIF, QuickSerializable {

    /**
     ** If inbound==true then peer is the guid of the node where
     ** this message came from; otherwise, it is the guid of the
     ** node where this message should be sent.
     */
    public SecureHash peer;

    /**
     * whether the event is an inbound message
     */
    public boolean inbound;

    /**
     * whether end to end MAC is enabled
     */
    public boolean usingMAC;

    /**
     * whether the MAC is verified
     */
    public boolean verifiedMAC;

    public TMessageEvent(SecureHash p, boolean inb,
	    boolean using, boolean verified) {

	peer = p;
	inbound = inb;
	usingMAC = using;
	verifiedMAC = verified;
    }

    public TMessageEvent (byte [] data, int [] offset) {
	// do nothing
    }


    public String toString() {
	return "(TMessageEvent "+peer+" "
	    + (inbound ? "inbound" : "outbound") + ")";
    }
}

