/**
 * Channel class.
 *
 * @author     Ling Huang
 * @version    $Id: Snippet.java,v 1.1 2002/08/16 15:12:49 hling Exp $
 */

package ostore.tapestry.channel;
import ostore.util.AssertionViolatedException;

public class Snippet 
{
    public byte [] data;
    public int offset, length, capacity;
    public Snippet next;

    public Snippet (int size) 
    { 
	if (size <= 0) 
	    throw new AssertionViolatedException ("size <= 0");
	data = new byte [size];
	offset = length = 0;
	capacity = size;
    }

    public Snippet (byte [] d, int o, int l) 
    {
	if (l <= 0) 
	    throw new AssertionViolatedException ("length <= 0");
	data = d; 
	offset = o;
	capacity = length = l; // don't allow changes
    }

    public Snippet (byte [] d, int o, int l, Snippet n) 
    {
	if (l <= 0) 
	    throw new AssertionViolatedException ("length <= 0");
	data = d; 
	offset = o;
	capacity = length = l; // don't allow changes
	next = n;
    }

    public Snippet (byte [] d, int o, int l, int c) 
    {
	if (c <= 0) 
	    throw new AssertionViolatedException ("capacity <= 0");
	data = d; 
	offset = o;
	length = l;
	capacity = c;
    }
}













