/**
 * DynamicPongMsg
 *
 * @author     Ben Y. Zhao
 * @version    $Id: DynamicPongMsg.java,v 1.9 2002/10/05 06:22:12 hweather Exp $
 */

package ostore.tapestry.impl;
import ostore.network.NetworkMessage;
import ostore.util.NodeId;
import ostore.util.OutputBuffer;
import ostore.util.InputBuffer;
import ostore.util.QuickSerializable;
import ostore.util.SecureHash;
import ostore.util.QSException;

public class DynamicPongMsg 
extends NetworkMessage implements QuickSerializable {
  
  public int type;
  public SecureHash src;

  public DynamicPongMsg (NodeId peer, SecureHash src, int type) {
    super (peer, false /* outbound */);
    this.src = src;
    this.type = type;
  }
  

  public DynamicPongMsg (InputBuffer buffer) throws QSException {
    super(buffer);
    src = (SecureHash) buffer.nextObject();
    type = buffer.nextInt();
  }

  public void serialize (OutputBuffer buffer) {
    super.serialize (buffer);
    buffer.add(src);
    buffer.add(type);
  }

  public Object clone () throws CloneNotSupportedException {
    DynamicPongMsg msg = (DynamicPongMsg) super.clone ();
    msg.src = src;
    msg.type = type;
    return msg;
  }
  
  public String toString () {
    return "(DynamicPongMsg of type:"+type+", from guid:"+src+", nodeid:" + peer+ ")";
  }
}

