package ostore.tapestry.impl.Shuttle;
import ostore.tapestry.impl.*;
import ostore.util.QSException;
import ostore.util.SecureHash;
import ostore.security.*;
import ostore.util.SHA1Hash;
import ostore.util.OutputBuffer;
import ostore.util.ByteUtils;
import ostore.util.TypeTable;
import ostore.tapestry.api.TapestryQuery;
import ostore.tapestry.api.TapestryQueryState;
import ostore.tapestry.api.TapestryLocateMsg;
import ostore.tapestry.api.TapestryRouteMsg;
import ostore.util.InputBuffer;
import ostore.util.QuickSerializable;

public class ShuttleFulfillStorageMsg 
    extends TapestryRouteMsg implements QuickSerializable {
    
    SecureHash key;
    String value;
    
    public ShuttleFulfillStorageMsg(SecureHash dest_guid, SecureHash key,
				    String value) {
	super(dest_guid);
	this.value = value;
	this.key = key;
    }
    
    public ShuttleFulfillStorageMsg(InputBuffer buffer) throws QSException {
	super(buffer);
	key = (SecureHash) buffer.nextObject();
	value = buffer.nextString();
    }

    public void serialize (OutputBuffer buffer) {
	super.serialize (buffer);
	buffer.add(key);
	buffer.add(value);
    }


    
    

    public String toString() {
	return "ShuttleFulfillStorageMsg key "+key+" value "
	    +value+" from/to="+ peer+")";
    }

    

}
