/**
 * TestFoundMsg.java
 *
 * @author     Ben Y. Zhao
 * @version    $Id: ShuttleTextMsg.java,v 1.8 2002/10/30 10:30:58 calvinh Exp $
 */

package ostore.tapestry.impl.Shuttle;

import ostore.tapestry.impl.*;

import ostore.util.QSException;
import ostore.util.SecureHash;
import ostore.util.OutputBuffer;
import ostore.util.ByteUtils;
import ostore.util.TypeTable;
import ostore.tapestry.api.TapestryRouteMsg;
import ostore.util.InputBuffer;
import ostore.util.QuickSerializable;

/**
 * The msg to say we found the object you're looking for
 */
public class ShuttleTextMsg 
    extends TapestryRouteMsg implements QuickSerializable {

    //public SecureHash objGuid;
    public String msg;
    public String sender;
    /*public ShuttleTextMsg (SecureHash dest_guid, SecureHash oguid) {
      super (dest_guid);
      this.objGuid = oguid;
      }*/
    public ShuttleTextMsg(SecureHash dest_guid, String sender, String msg)
    {
	super(dest_guid);
	this.msg = msg;
	this.sender = sender;
    }

    public ShuttleTextMsg (InputBuffer buffer) throws QSException {
	super(buffer);
	msg = buffer.nextString();
	sender = buffer.nextString();
    }

    public void serialize (OutputBuffer buffer) {
	super.serialize(buffer);
	buffer.add(msg);
	buffer.add(sender);
    }


  public String toString() {
    return "(ShuttleTextMsg for msg= "+msg+", from/to="+ peer+ ")";
  }

    
}


/*OLD version
      public ShuttleTextMsg (byte[] data, int[] offset)
      throws QSException {
      
      long type = ByteUtils.bytesToLong(data, offset);
      //msg = (String) TypeTable.new_object(type,data,offset);
      sender = ByteUtils.bytesToString(data, offset);
      
      type = ByteUtils.bytesToLong(data, offset);
      msg = ByteUtils.bytesToString(data, offset);
      }*/
  
