/**
 * TestClient.java
 *
 *  @author     Ben Y. Zhao
 *  @version    $Id: TestShuttle.java,v 1.11 2003/02/19 10:32:31 hweather Exp $
 *  Copyright (c) 2001 Regents of the University of California.  All
 *  rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above
 *     copyright notice, this list of conditions and the following
 *     disclaimer in the documentation and/or other materials provided
 *     with the distribution.
 *  3. Neither the name of the University nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS
 *  IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE
 *  REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 *  (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 *  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 *  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 *  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 *  OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 *  EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package ostore.tapestry.impl.Shuttle;
import ostore.tapestry.impl.*;
import java.util.*;
import java.io.*;
import java.security.*;
import ostore.util.*;
import ostore.dispatch.*;
import ostore.tapestry.*;
import ostore.tapestry.api.*;
import ostore.dataobj.*;
import ostore.update.*;
import ostore.security.*;
import ostore.security.thresh.*;
import ostore.startrek.*;
import seda.sandStorm.api.*;
import seda.sandStorm.core.*;
import seda.sandStorm.internal.SinkProxy;
import cryptix.jce.provider.random.DevRandom;



import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class TestShuttle
    implements EventHandlerIF, ProfilableIF {


    public String class_tag = "Test";

    //public TestShuttle() {
    //super("Shuttle");
    //}

    private void dispatch (QueueElementIF item) {
	try {
	    _classifier.dispatch(item);
	} catch (SinkException e) {
	    Carp.out ("Could not dispatch " + item);
	    System.exit (1);
	}
    }

    public void handleEvents(QueueElementIF items[]) 
    throws EventHandlerException {
	for(int i=0; i<items.length; i++)
	    handleEvent(items[i]);
    }

    public void printtagln(String tag, String msg) {
        System.err.print(tag+":"+msg+"\n");
    }

    public void init (ConfigDataIF config) throws Exception {

	DEBUG = true;
	
	_running = 0;
	timer = new ssTimer();
	
	Types.registerAllTypes ();

	_classifier = Classifier.getClassifier (
                new NodeId (config.getString ("node_id")));
	
	//initialize the numerical arguments
	_oldobjs = Integer.parseInt(config.getString ("oldobjs"));
	_numid = config.getString ("nameindex");
	_id = Integer.parseInt(_numid);

	_self_node_id = new NodeId (config.getString ("node_id"));

	class_tag = class_tag + ".["+_self_node_id.port()+"]";
	if (DEBUG) ostore.util.Debug.turnOn(class_tag);

	final String tag = class_tag +".init";
	String on = config.getString("power");
	if (on != null && on.equalsIgnoreCase("off")) return;



	/* /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\\/\\/\/ */
	/*Added By Calvin: get our login String and our contact list
	 *Publish our login in String & tell everyone that we're online*/

	
	_login = null;
	_shuttleState = SHUTTLE_LOGGED_OUT;


	//numContacts = 0;
	_contactList = new String[0];

	//right now ... contact list is hacked in the config file!
	/*
	  numContacts = config.getInt("numcontacts");
	  if(numContacts < 0) numContacts = 0;	
	  _contactList = new String[numContacts];
	  for(int i=0; i<numContacts; i++) {
	  _contactList[i] = new String( config.getString("contact"+i) );
	  _contactList[i] = _contactList[i].trim();	  
	  }*/

	
	
	_onlineContactList = new HashMap();
	_storage = new HashMap();
	
	
	
	String stageName = config.getStage().getName();
	try 
	{
	  if(config.getBoolean("Profile"))
	  {
	    config.getManager().getProfiler().add("ostore.tapestry.impl.TestShuttle", this);
	    SinkIF sink =
	      config.getManager().getStage(stageName).getSink();
	    this_sink = new SinkProxy(sink,
				      config.getManager(),
				      config.getStage().getWrapper());
	  }
	  else
	    this_sink =
	      config.getManager().getStage(stageName).getSink();
	} 
	catch (NoSuchStageException e) 
	{
	  Carp.die (tag + ": could not get own sink.");
	}

	Filter filter;
	String [] event_types = {
	  "seda.sandStorm.api.StagesInitializedSignal",
	  "ostore.tapestry.impl.TapestryReadyMsg",	  
	};	  

	for (int i=0; i< event_types.length; i++) {
	  filter = new Filter ();
	  if (! filter.requireType (Class.forName(event_types[i]))) {
	    Carp.out ("Could not require type " + event_types[i]);
	    System.exit (1);
	  }
	  _classifier.subscribe (filter, this_sink);
	}

	String [] msg_types = {
	    "ostore.tapestry.impl.Shuttle.ShuttleLocateMsg",
	    "ostore.tapestry.impl.Shuttle.ShuttleTextMsg",
	    "ostore.tapestry.impl.Shuttle.ShuttleHelloMsg",
	    "ostore.tapestry.impl.Shuttle.ShuttleGoodbyeMsg",
	    "ostore.tapestry.impl.Shuttle.ShuttleRequestStorageMsg",
	    "ostore.tapestry.impl.Shuttle.ShuttleFulfillStorageMsg",
	    "ostore.tapestry.impl.Shuttle.PingMsg"
	};

	for (int i=0; i< msg_types.length; i++) {
	  filter = new Filter ();
	  if (! filter.requireType (Class.forName(msg_types[i])))
	    Carp.die ("Could not require type " + msg_types[i]);
	  if (! filter.requireValue("inbound", new Boolean(true)))
	    Carp.die ("Could not require inbound = true for "+
		      msg_types[i]);
	  _classifier.subscribe (filter, this_sink);
	}

	System.out.println("TestShuttle Tapestry stage initialized!!");
	
	
	//_mainShuttleFrame = new MainShuttleFrame(this);
	//_mainShuttleFrame.make_hidden();
	
	_loginFrame = new LoginFrame(this);
	_loginFrame.make_visible();
	//InitShuttleFrame();  /*Intialize the frame */
	
	//updateContactTextArea();

	//just for debugging purposes
    }

  public void handleEvent(QueueElementIF item) 
    throws EventHandlerException {

      DEBUG = false;  
    final String tag = class_tag+".handleEvent";

    if (item instanceof StagesInitializedSignal) {
 
      /*  /\/\/\/\/\/\/\/\/\/\/ Added by Calvin */
      //Add ourself into the list of contacts

      //_onlineContactList.put(_login, _client_guid);
      
    } else if (item instanceof TapestryReadyMsg) {

	_client_guid = ((TapestryReadyMsg)item).node_guid;
	//System.out.println("our hash is  " + _onlineContactList.get(_login));
	System.out.println("our hash is " + _client_guid);

	ReadStorageFromDisk();

	if(_running == 0) {

	    //PUBLISH THE FACT THAT WE ARE ONLINE
	    //NOTE: Do This after user logs in
	    
	    //byte[] loginBytes = _login.getBytes();
	    //SHA1Hash nameHash = new SHA1Hash(loginBytes);	
	    //TapestryPublishMsg tpm = new TapestryPublishMsg(nameHash, null);
	    //System.out.println("PUBLISHING "+_login+" as "+nameHash);
	    //dispatch(tpm);

	    _running = 1;
	    timer.registerEvent(2000, item, this_sink);
	}else{
	    //NOW we have to try to find our contacts
	    /*    
		  for(int i=0; i<_contactList.length; i++) {
		  byte[] contactBytes = _contactList[i].getBytes();
		  SecureHash buddyHash = new SHA1Hash(contactBytes);
		  //CRAP			
		  TestLocateMsg tlm = new TestLocateMsg(buddyHash,null, null);	
		  dispatch(tlm);
		  //timer.registerEvent(2000, item, this_sink);
		  }*/
	    

	    //Fire off a message to retrieve our contact list length
	    //RetrieveValueFromNetwork(_login+"contactlistlength");

	}
	
    } else if (item instanceof ShuttleLocateMsg) {
	/*Find who we just located*/
	ShuttleLocateMsg msg = (ShuttleLocateMsg) item;
	ShuttleHelloMsg helloMsg = new ShuttleHelloMsg(msg.peer, msg.guid);
	dispatch(helloMsg);

	for(int i=0; i<_contactList.length; i++) {
	    SecureHash contactHash = new SHA1Hash(_contactList[i].getBytes());
	    if(msg.senderGUIDHash.equals(contactHash)) {
		_onlineContactList.put(_contactList[i], msg.peer);
	    }
	    updateContactTextArea();
	}
		
    }else if (item instanceof ShuttleHelloMsg) {
	ShuttleHelloMsg msg = (ShuttleHelloMsg) item;
	synchronized (_contactList) {
	    if(DEBUG)
		System.out.println(_login+"'s Contact LIst length: "+_contactList.length);
	    for(int i=0; i<_contactList.length; i++) {
		if(_contactList[i] == null) {
		    if(DEBUG)
			System.out.println(_login+"'s !!!!!!!!!!!1  Contact list "+i+" is null!!!");
		}else{
		    SecureHash contactHash = new SHA1Hash(_contactList[i].getBytes());
		    if(msg.objGuid.equals(contactHash)) {
			_onlineContactList.put(_contactList[i], msg.peer);
		    }
		}
	    
		updateContactTextArea();
	    }
	}
 
   
    } else if (item instanceof ShuttleGoodbyeMsg) {
	ShuttleGoodbyeMsg msg = (ShuttleGoodbyeMsg) item;
	if (_onlineContactList.get(msg.sender) != null)
	    _onlineContactList.remove(msg.sender);
	// may have to do a final store using a PrefixRouteMsg before exiting
	updateContactTextArea();
	
    }else if (item instanceof ShuttleTextMsg) {
	ShuttleTextMsg msg = (ShuttleTextMsg) item;
	if(DEBUG) {
	    System.out.println("Recieved a text message");
	    System.out.print("<"+msg.sender+">: ");
	    System.out.println(msg.msg);
	}
	/*ShuttleIOToMsg toMsg = new ShuttleIOToMsg();
	  toMsg.msgType = ShuttleIOToMsg. SHUTTLEIO_RECEIVEDTEXTMESSAGE;
	  toMsg.msg = msg.msg;
	  toMsg.sender = msg.sender;
	
	  dispatch(toMsg); */
	//DisplayToUser("<"+msg.sender+"> : "+msg.msg+"\n");
	HandleChatReceiveMsg(msg.sender, msg.msg);

    }else if(item instanceof ShuttleFulfillStorageMsg) {
	ShuttleFulfillStorageMsg msg = (ShuttleFulfillStorageMsg) item;
	if(DEBUG) System.out.println("AAHH.   SHUTTLE state = "+_shuttleState);
	if(_shuttleState == SHUTTLE_LOGGED_OUT){
	    //No examples of being logged out and getting a fullfillmsg
	}
	else if(_shuttleState == SHUTTLE_LOGGING_IN) {
	    //see if we are getting name/value tuple
	    
	    if(msg.key.equals(new SHA1Hash(_login+"password"))) {
		SecureHash s = new SHA1Hash(_password);
		if((!msg.value.equals("")) && (msg.value.equals(s.toString().trim()))) {
		    //Log in
		    CompleteLogin();
		    _shuttleState = SHUTTLE_LOGGED_IN;
		}else{
		    //DisplayErrorMessage
		    if(DEBUG) System.out.println("!! value is "+msg.value+"compared to "+s.toString());
		    _loginFrame.incorrect_pw_notify();
		    _shuttleState = SHUTTLE_LOGGED_OUT;
		}
	    }
	}
	
	else if(_shuttleState == SHUTTLE_LOGGED_IN) {
	    if(msg.key.equals(new SHA1Hash(_login+"contactlistlength")) && (!msg.value.equals( ""))) {
		if(DEBUG) System.out.println("MSG.VALUE (CONTACT):::"+msg.value);
		int numContacts = Integer.parseInt(msg.value);
		
		synchronized(_contactList) {
		    if(DEBUG) System.out.println(_login+"'s contact List now has "+numContacts+"+ contacts");
		    _contactList = new String[numContacts];	       
		    //now request all of our contacts from the network
		    for(int i=0; i<numContacts; i++) {
			_contactList[i] = new String("*unavailable*");
			RetrieveValueFromNetwork(new SHA1Hash(_login),_login+"contact"+i);
		    }
		}

	    }else{
		for(int i=0; i<_contactList.length; i++) {
		    if((!msg.value.equals("")) && msg.key.equals(new SHA1Hash(_login+"contact"+i))) {
			_contactList[i] = msg.value;		    
			byte[] contactBytes = _contactList[i].getBytes();
			SecureHash buddyHash = new SHA1Hash(contactBytes);		    
			//ShuttleLocateMsg tlm = new ShuttleLocateMsg(buddyHash,null, null);	
			ShuttleLocateMsg tlm = 
			    new ShuttleLocateMsg(buddyHash, (SecureHash) new SHA1Hash(_login.getBytes()));

			dispatch(tlm);
		    }
		}
		updateContactTextArea();
	    }
	}
	
    }else if(item instanceof ShuttleRequestStorageMsg) {
	ShuttleRequestStorageMsg storeRequest = (ShuttleRequestStorageMsg) item;
	String requestedValue = null;
	//System.out.println("Got store request type "+storeRequest.requestType+" value="+storeRequest.value);
	
	if(storeRequest.requestType.trim().equals("store"))  {
	    StoreTuple(storeRequest.key, storeRequest.value);
	}else if (storeRequest.requestType.trim().equals("retrieve")) {
	    requestedValue = (String) RetrieveTuple(storeRequest.key);
	    if(requestedValue != null) {

		ShuttleFulfillStorageMsg fulfillment = new ShuttleFulfillStorageMsg(storeRequest.peer,
										    storeRequest.key, requestedValue);
		dispatch(fulfillment);
	    }else {
		if(DEBUG) System.out.println("Could not find match for given key");
		
		ShuttleFulfillStorageMsg notFoundFulfillment = new ShuttleFulfillStorageMsg(storeRequest.peer,
											    storeRequest.key,
											    "");
		dispatch(notFoundFulfillment);
	    }
	    
	}else{
	    if(DEBUG) System.out.println("Received Unkown request type");
	}
	
    } else {
      Carp.die ("ostore.tapestry.impl.ShuttleTest: Received unknown "
		+ "QueueElementIF: " + item);
    }
  }
  





    /* \/\/\/\/\/\/\/\/\/\\/\/\/\/\\/\/\/\/\\/\/\/\/\\/\/\/\/\\/\/\/\/\\/\/\/\/\
       // Methods used by the Shuttle Application
       //I tried my best to organize these into coherent groups!
       ///\/\/\/\//\/\/\/\/\/\/\/\/\/\/\/\/\/\/\///\//\/\/\/\/\/\/\/\//\/\/\//\/\/
    */
    
      
    /* **********************************************************************
     * DoGoodbye
     *
     * THis method is called from the _mainShuttleFrame (see MainShuttleFrame.java)
     * It handles logging a user off and closing all the windows he/she had open
     *************************************************************************/
    public synchronized void DoGoodbye()
    {

	byte[] loginBytes = _login.getBytes();
	SHA1Hash nameHash = new SHA1Hash(loginBytes);	
	TapestryUnpublishMsg tupm = new TapestryUnpublishMsg(nameHash, null);
	dispatch(tupm);


	for (Iterator iterator = _onlineContactList.keySet().iterator(); iterator.hasNext();) {
	    String key = (String) iterator.next();
	    ShuttleGoodbyeMsg gbmsg = new ShuttleGoodbyeMsg((SecureHash) _onlineContactList.get(key), _login);
	    dispatch(gbmsg);
	}
	
	WriteStorageToDisk();

	Iterator i = _currentChatWindows.values().iterator();
	
	while(i.hasNext()) {
	    ((ChatFrame) i.next()).dispose();
	}			
	_currentChatWindows = null;

	_loginFrame = new LoginFrame(this);
	_loginFrame.make_visible();

	_mainShuttleFrame.dispose();
	_mainShuttleFrame = null;
	
	_shuttleState = SHUTTLE_LOGGED_OUT;

	_login = null;
	_contactList = new String[0];
	_onlineContactList = new HashMap();
    }

      
    

    public synchronized void MakeNewUser(String userName, String password)
    {
	SecureHash pwKeyString = new SHA1Hash(password);      
	StoreValueInNetwork(new SHA1Hash(userName),userName+"password", pwKeyString.toString().trim());
	//StoreValueInNetwork(userName+"password",password);
    }
    
    public synchronized void InitiateLogin(String userName, String password)
    {
	_login = userName;
	SecureHash s =new SHA1Hash(password);
	
	_password = password;
	_shuttleState = SHUTTLE_LOGGING_IN;
	RetrieveValueFromNetwork(new SHA1Hash(userName), userName+"password");	
    }

    private void CompleteLogin()
    {
	byte[] loginBytes = _login.getBytes();
	SHA1Hash nameHash = new SHA1Hash(loginBytes);	
	TapestryPublishMsg tpm = new TapestryPublishMsg(nameHash, null);
	if(DEBUG) System.out.println("PUBLISHING "+_login+" as "+nameHash);
	dispatch(tpm);

	RetrieveValueFromNetwork(new SHA1Hash(_login),_login+"contactlistlength");

	//_mainShuttleFrame.make_visible();
	//_loginFrame.make_hidden();
	//updateContactTextArea();
	_mainShuttleFrame = new MainShuttleFrame(this);
	_mainShuttleFrame.make_visible();
	
	_loginFrame.dispose();
	_loginFrame = null;
	_currentChatWindows = new HashMap();
    }



    //***************************************************************************
    //* THe following 2 methods are used to maintain buddy lists
    //* NOTE: BOth of these methods are called from the
    //* AddRemoveFrame (see AddRemoveContactFrame.java)
    //***************************************************************************
    public synchronized void RemoveContact(String contactName)
    {
	int x,y;
	
	int numContacts = _contactList.length;
	
	synchronized(_contactList) {	    
	    if (existInList(_contactList, contactName)) {
		String[] reducedContactList = new String[numContacts - 1];
		
		for (x=0, y=0; y <numContacts  - 1;x++, y++) {
		    if (_contactList[x].equals(contactName)) 
			{
			    //RemoveValueFromNetwork(new String(_login+"contact"+x), contactName);
			    x++;
			}
		    reducedContactList[y] = _contactList[x];
		}
		
		_contactList = reducedContactList;
		numContacts--;
	    }
	    if (_onlineContactList.get(contactName) != null)
		_onlineContactList.remove(contactName);
	    
	}
	    StoreValueInNetwork(new SHA1Hash(_login), _login+"contactlistlength", Integer.toString(numContacts));
	    updateContactTextArea();
	
    }

    /* Called from AddRemoveContactFrame.java */
    public synchronized void AddContact(String contactName)
    {
	int b;
	int numContacts = _contactList.length;
	synchronized(_contactList) {	 
	    String[] newContactList = new String[numContacts + 1];
	    for ( b = 0; b < _contactList.length; b++) {
		if (_contactList[b].equals(contactName)) 
		    return; //Contact already exists
	    }
	    
	    if (b ==  _contactList.length) {
		System.arraycopy(_contactList, 0, newContactList, 0, _contactList.length);
		newContactList[b] = contactName;
		_contactList = newContactList;
	    }
	    numContacts++;
	}

	byte[] buddyBytes = contactName.getBytes();
	SecureHash buddyByteHash = new SHA1Hash(buddyBytes);
	ShuttleLocateMsg tlm1 = new ShuttleLocateMsg(buddyByteHash, (SecureHash) new SHA1Hash(_login.getBytes()));
	dispatch(tlm1);
	
	//We want to store this value out into ostore ... for now just get the best guy and store it
	//NOTE: The following are used as keys to store data (check the protocol)
	//  store tuples (a, b) into ocean store
	//  for storing the size of the contact list, use: 
	//     a = mylogin + "contactlistlength" + x ... where x is the number of contacts
	//     b = numberOfContacts
	//  for storing indivual contact tuples use:
	//     a = mylogin + "contact0" ... or contact1 etc.
	//	 b = contactName 
	StoreValueInNetwork(new SHA1Hash(_login), _login+"contactlistlength", Integer.toString(numContacts));
	StoreValueInNetwork(new SHA1Hash(_login), new String(_login+"contact"+(numContacts-1)), contactName);  
	
	updateContactTextArea();
    }
			   






	//  CODE HERE SIMULATES DISTRIBUTED STORAGE by simple writing a hash map to disk
	
    /* ***********************************************************************************
     * setStoreLocal()
     * 
     * Sets our storage method as local: store all contact information (and login info)
     * in a local hashmap
     * *********************************************************************************/

    public void SetStoreLocal() {
	_storageMethod = SHUTTLE_STORE_LOCAL;
    }

    /* ***********************************************************************************
     * setStoreNetwork()
     * 
     * Sets our storage method as network: store all contact information (and login info)
     * in the network
     * *********************************************************************************/
    
    public void SetStoreNetwork() {
	_storageMethod = SHUTTLE_STORE_NETWORK;
    }
    


    
    /* ********************************************************************  
     * StoreValueInNetwork(a, b)
     *  stores the tuple a, b in network
     *  Eventually we will use some oceanstore functionality ... but oceanstore isnt ready, so for right now
     *  use PrefixRouteMessage (RequestStorage extends this) to store the tuple @ the
     *  best possible neighbor 
     * Addition!!: If _storageMethod is set to local, we will just store all the data on the local data structure
     * *************************************************************************************/
    
     public void StoreValueInNetwork(SecureHash dest_guid, String a, String b) {

	if(_storageMethod == SHUTTLE_STORE_LOCAL)
	    dest_guid = _client_guid;

	SecureHash key = new SHA1Hash(a.trim());
	
	//SecureHash dest_guid = new SHA1Hash(_login);
	//ShuttleRequestStorageMsg request = new ShuttleRequestStorageMsg(_client_guid);
	ShuttleRequestStorageMsg request = new ShuttleRequestStorageMsg(dest_guid);
	request.InitStoreRequest(key, b.trim());
	dispatch(request);
    }

    public void RetrieveValueFromNetwork(SecureHash dest_guid, String key) {
	
	if(_storageMethod == SHUTTLE_STORE_LOCAL)
	    dest_guid = _client_guid;

	//SecureHash dest_guid = new SHA1Hash(_login);

	//ShuttleRequestStorageMsg request = new ShuttleRequestStorageMsg(_client_guid);
	ShuttleRequestStorageMsg request = new ShuttleRequestStorageMsg(dest_guid);

	SecureHash hashKey = new SHA1Hash(key);
	request.InitRetrieveRequest(hashKey);
	dispatch(request);
	if(DEBUG) System.out.println("Trying to retrieve value from network (key): "+key);
    }
    
    
    private void StoreTuple(SecureHash key, Object value) 
    {
	//System.out.println("Storing tuble ("+key+", "+value+")");
	
	_storage.put(key, value);
    }

    private Object RetrieveTuple(SecureHash key)
    {
	//System.out.println("Retrieving tuple key="+key);

	return _storage.get(key);
    }

    
    /* Writes our storage to disk ....
     * This function assumes that the key is a SecureHash and
     * that the value is a string! */
    private void WriteStorageToDisk()
    {
	Iterator i = _storage.entrySet().iterator();
	Map.Entry e;
	SecureHash key;
	String value;
	//FileWriter fw;
	RandomAccessFile fw;
	RandomAccessFileOutputBuffer outputBuff = null;
	byte[] arrayToWrite = null;

	//int[] offset = new int[1];
	
	//hacked way to delete the existing file
	try{
	    File f = new File("data"+_client_guid+".storage");
	    f.delete();
	}catch(Exception exc) {
	    //do nothing ...
	}

	try {
	    fw =  new RandomAccessFile("data"+_client_guid+".storage", "rw");
	    outputBuff = new RandomAccessFileOutputBuffer(fw);

	    //fw.writeInt(_storage.entrySet().size());
	    outputBuff.add(_storage.entrySet().size());
	    if(DEBUG) System.out.println("Wrote: _entryset().size():" +_storage.entrySet().size());

	    while(i.hasNext()) {
		if(DEBUG) System.out.print(".");
		e = (Map.Entry) i.next();
		key = (SecureHash)e.getKey();
		value = (String)e.getValue();
		
		//System.out.println("Writing key/value to disk : ("+key+","+value+")");
		outputBuff.add(key);
		outputBuff.add(value);
		
	    }
	    fw.close();
	}catch(Exception ex){
	    ex.printStackTrace();
	}
	
    }

    /* Reads our storage from disk (data locally stored for other nodes)
       This function assumes that the key is a SecureHash and
       that the value is a String! */
    private void ReadStorageFromDisk() 
    {
	RandomAccessFile fr = null;
	RandomAccessFileInputBuffer inputBuff = null;

	int numPairs;

	//int[]offset = new int[1];
	SecureHash key;
	String value;
	
	try {
	    fr = new RandomAccessFile("data"+_client_guid+".storage", "r");
	    inputBuff = new RandomAccessFileInputBuffer(fr);
	}catch(FileNotFoundException ex) {
	    if(DEBUG) {
		System.out.println("No existing storage file");
		System.out.println("could not open file: data"+_client_guid+".storage");
	    }
	    return;
	}

	try {
	    numPairs = inputBuff.nextInt();
	    if(DEBUG) System.out.println("NumPairs: "+numPairs);
	    for(int i=0; i<numPairs; i++)
		{
		    key = (SecureHash) inputBuff.nextObject();
		    value = inputBuff.nextString();
		    if(DEBUG) System.out.println("Read tuple <"+key+">, <"+value+"> from disk!!");
		    _storage.put(key, value);		
		}
	    	    
	    fr.close();
	}catch(Exception e) {
	    e.printStackTrace();
	}
    }


    /************************************************						     
	//  End of DISK storage methods!!!!	
    *********************************************/

    /* ******************************************************************
     * GetLogin:
     *
     * returns login string
     *******************************************************************/
    public String GetLogin()
    {
	return _login;
    }

    


    /* *************************************************************************
     * This method tells the main shuttle frame (which holds the contact list, etc)
     * to update the contact list because we made a change to the underlying
     * data structures that hold the contact list
     ****************************************************************************/
    private void updateContactTextArea()
    {
	String contact;
	String newText;
	
	/*
	  if(_login == null) //we are not logged in
	  {
	  //contactTextArea.setText("NOT LOGGED IN");
	  _mainShuttleFrame.setContactTextArea("NOT LOGGED IN");
	  return;
	  }
	  newText = new String(_login+"'s Contact List:\n");
	  for(int i=0; i<_contactList.length; i++) 
	  {
	  contact = _contactList[i];
	  if(_onlineContactList.containsKey(contact))
	  contact = "*" + contact;
	  newText += contact;
	  newText += "\n";
	  
	  }
	  _mainShuttleFrame.setContactTextArea(newText);*/
	
	//_mainShuttleFrame.setContactList(_contactList);
	if(_shuttleState == SHUTTLE_LOGGED_IN)
	    _mainShuttleFrame.setContactList(_contactList,
					     _onlineContactList.keySet().toArray());
    }

    private void DisplayToUser(String s)
    {
	_mainShuttleFrame.displayTextToUser(s);     
    }




    /* **************************************************************
     * HandleChatReceiveMsg handles a text msg received byt his user
     * (Sent by antoher user)
     * This method is called from HandleEvent, when we receive a txt msg
     ****************************************************************/
    public synchronized void HandleChatReceiveMsg(String contact, String msg)
    {
	//check if person isnt on ur buddy list?
	
	ChatFrame c = (ChatFrame) _currentChatWindows.get(contact);
	if(c == null) {
	    c = new ChatFrame(contact, this);
	    c.make_visible();
	    _currentChatWindows.put(contact, c);
	}
	c.addChatText(contact, msg);
    }


    /* ***********************************************************************
     * HandeChatFrameClosing
     * This method handles the case where we have a current conversatin going on
     * via ChatFrame (see ChatFrame.java).  THe user then closes that chat window
     * TestShuttle keeps track of all the current chat windows, so it knows
     * where to send text messages that are received.  When a window is closed,
     * handlechatframeclosing updates the appropiate data structures
     *************************************************************************/

    public synchronized void HandleChatFrameClosing(String contact, ChatFrame cf)
    {
	if( _currentChatWindows.get(contact) == cf ) {
	    _currentChatWindows.remove(contact);
	}
	cf = null;
    }



    /* ***************************************************************
     * HandleChatSendMsg
     *
     * This method is called from ChatFrame (see ChatFrame.java)
     * it is called to handle a user wanting to send a text msg
     ****************************************************************/

    public synchronized void HandleChatSendMsg(ChatFrame cf, String contact, String msg)
    {
	SecureHash to = (SecureHash) _onlineContactList.get(contact);
	if(to == null) {
	    DisplayToUser("ERROR: user "+contact+" is not online");
	    return;
	}
	ShuttleTextMsg stm = new ShuttleTextMsg(to, _login, msg);
	dispatch(stm);
	
	cf.addSelfChatText(_login, msg);
    }


    
    /* **************************************************************
     * InitChatMsg
     *
     * This method is called from InitChatFrame.  It basically sends
     * a text msg to the speicifed user, and changes the window to
     * a "conversation"-style window, which is a ChatFrame
     * See InitChatFrame.java and ChatFrame.java
     ****************************************************************/

    public synchronized void InitChatMsg(String contact, String msg)
    {
	SecureHash to = (SecureHash)_onlineContactList.get(contact);
	//Make sure that contact is online
	if(to == null) {
	    DisplayToUser("ERROR: user "+contact + " is not online");
	    return;
	}
	ChatFrame c = (ChatFrame) _currentChatWindows.get(contact);
	if(c == null) {
	    c = new ChatFrame(contact, this);
	    c.make_visible();
	    _currentChatWindows.put(contact, c);
	}
	
	ShuttleTextMsg stm = new ShuttleTextMsg(to, _login, msg);
	dispatch(stm);
	c.addSelfChatText(_login, msg);	
    }



    /* *************************************************************
     * HandleInput
     *
     * This is called from MainShuttleFrame.java
     * It basically handles command line inputs
     * I am slowly phasing this out, for a more graphical user-friendly
     * approach
     ******************************************************************/
    public void HandleInput(String userInput)
    {
	String recipient = "";
       
	StringTokenizer st = new StringTokenizer(userInput, " ");
	if(!st.hasMoreTokens()) return;
	String msgType = st.nextToken();
	String msg = "";
	msgType = msgType.trim().toLowerCase();
	
	if(msgType.equals("sendtextmessage")) {
	    recipient = st.nextToken();
	    while(st.hasMoreTokens()) {
		msg += st.nextToken();
		msg += " ";
	    }
	    SecureHash to = (SecureHash) _onlineContactList.get(recipient);
	    if(to == null) {
		//Give an error message
		DisplayToUser("ERROR: SendTextMessage: Reciepient does not exist!\n");
	    } else {
		ShuttleTextMsg shuttleTextMsg = new ShuttleTextMsg(to, _login,msg);
		dispatch(shuttleTextMsg);
	    }
	    //ioMessage = new ShuttleIOFromMsg(ShuttleIOFromMsg.SHUTTLEIO_SENDTEXTMESSAGE, recipient, msg);
	}else if (msgType.equals("addcontact")) {
	    AddContact(st.nextToken().trim());
	    //ioMessage = new ShuttleIOFromMsg(ShuttleIOFromMsg.SHUTTLEIO_ADDCONTACT, st.nextToken().trim(), null);
	}else if (msgType.equals("removecontact")) {
	    RemoveContact(st.nextToken().trim());
	    //ioMessage = new ShuttleIOFromMsg(ShuttleIOFromMsg.SHUTTLEIO_REMOVECONTACT, st.nextToken().trim(), null);
	}else if (msgType.equals("goodbye")) {
	    DoGoodbye();
	    //ioMessage = new ShuttleIOFromMsg(ShuttleIOFromMsg.SHUTTLEIO_GOODBYE, null, null);
	}else if (msgType.equals("whoami")) {
	    //ioMessage = new ShuttleIOFromMsg(ShuttleIOFromMsg.SHUTTLEIO_WHOAMI, null, null);
	}else if (msgType.equals("ping")) {
	    //ioMessage = new ShuttleIOFromMsg(ShuttleIOFromMsg.SHUTTLEIO_PING, st.nextToken().trim(), null);
	    
	}else if (msgType.equals("newuser")) {
	    MakeNewUser(st.nextToken().trim(), st.nextToken().trim());
	}else if (msgType.equals("login")) {
	    InitiateLogin(st.nextToken().trim(), st.nextToken().trim());
	}else if(msgType.equals("?")) {
	    System.out.println("Available commands are: ");
	    System.out.println("getonlinecontacts, getallcontacts, getofflinecontacts, sendtextmessage, addcontact, removecontact, goodbye, whoami");

	}else{
	    System.out.println("Unrecognized command (type ? for help): "+msgType);
	}
	    
	//if(msg != null)
	//    dispatch(ioMessage);
    }


    


    public boolean existInList(String[] link, String id) {
	for (int i= 0; i < link.length; i++) {
	    if (link[i].equals(id) )
		return true;
	}
	return false;
    }
    
    public void destroy() throws Exception {
    // TODO
  }

    //  methods for ProfilableIF
    /* Specified by seda.sandStorm.api.ProfilableIF */
    public int profileSize()
    {
	return this_sink.size();
    }
    //  end methods for ProfilableIF

    public static String printGuid (SecureHash guid) {
        String out="";
	int [] gdigits = RoutingTable.digits(guid);
	for (int i = 0; i < gdigits.length; ++i) {
	    out += Integer.toHexString (gdigits [i]);
	}   
	return out;
    }


    //This variable is set by the methods
    //setStoreLocal and setStoreNetwork
    private int _storageMethod = SHUTTLE_STORE_NETWORK;

    public static final int SHUTTLE_STORE_LOCAL = 0;
    public static final int SHUTTLE_STORE_NETWORK = 1;


    private MainShuttleFrame   _mainShuttleFrame = null;
    private LoginFrame _loginFrame = null;

    public static final int SHUTTLE_LOGGED_OUT = 0;
    public static final int SHUTTLE_LOGGING_IN = 1;
    public static final int SHUTTLE_LOGGED_IN = 2;

    private int _shuttleState;

  private boolean DEBUG;
  private String _numid;
  private int _id;
  private int _oldobjs;
  private SecureHash _client_guid;
  
    //private HashMap _guid_located;  //guid->bool: done locatemsg on them
  
  private SinkIF this_sink;

  private NodeId _self_node_id;
  private Classifier _classifier;


    /* Added by Calvin*/
 
    private ssTimer timer;

    private int _running;
    public long pingTime;
    private HashMap _onlineContactList;  //map of contacts to NodeIDs
    private String _login;
    private String _password;

    private String [] _contactList;
    

    /* Stuff after here is used to mimic oceanstore ... */
    private HashMap _storage;


    private HashMap _currentChatWindows;
    //hash  <contactName> -> ChatWindow

    
}



