/**
 * StaticAllNodesMsg.
 *
 * @author     Sean C. Rhea
 * @version    $Id: StaticAllNodesMsg.java,v 1.11 2002/07/20 19:38:03 srhea Exp $
 */

package ostore.tapestry.impl;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import ostore.network.NetworkMessage;
import ostore.util.ByteUtils;
import ostore.util.InputBuffer;
import ostore.util.NodeId;
import ostore.util.QSException;
import ostore.util.SecureHash;
import ostore.util.OutputBuffer;
import ostore.util.TypeTable;
import ostore.util.QuickSerializable;
import ostore.util.InputBuffer;
import ostore.util.QuickSerializable;

public class StaticAllNodesMsg 
extends NetworkMessage implements QuickSerializable {

    public StaticAllNodesMsg (NodeId peer, Map nodes) {
	super (peer, false /* outbound */);
	_nodes = nodes;
    }

    public StaticAllNodesMsg (InputBuffer buffer) 
    throws QSException {
	super (buffer);
	int count = buffer.nextInt ();
	_nodes = new HashMap (count);
	for (int i = 0; i < count; ++i) {
	    NodeId n = (NodeId) buffer.nextObject ();
	    SecureHash g = (SecureHash) buffer.nextObject ();
	    _nodes.put (n, g);
	}
    }

    public Map nodes () { return _nodes; }

  
    public void serialize (OutputBuffer buffer) {
      super.serialize (buffer);
      buffer.add(_nodes.size());
      for (Iterator i = _nodes.keySet ().iterator (); i.hasNext (); ) {
	NodeId n = (NodeId) i.next ();
	SecureHash g = (SecureHash) _nodes.get (n);
	buffer.add(n);
	buffer.add(g);
      }
    }

    public Object clone () throws CloneNotSupportedException {
	StaticAllNodesMsg result = (StaticAllNodesMsg) super.clone ();
	result._nodes = _nodes;
	return result;
    }

    public String toString () {
	// TODO
	return "(StaticAllNodesMsg " + super.toString () + ")";
    }

    public Map _nodes;
}

