/*
 *  TapestryReadyMsg.java
 *
 *  Copyright (c) 2001 Regents of the University of California.  All
 *  rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above
 *     copyright notice, this list of conditions and the following
 *     disclaimer in the documentation and/or other materials provided
 *     with the distribution.
 *  3. Neither the name of the University nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS
 *  IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE
 *  REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 *  (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 *  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 *  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 *  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 *  OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 *  EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package ostore.tapestry.impl;
import ostore.util.SecureHash;
import seda.sandStorm.api.QueueElementIF;

/**
 * Message sent by either StaticTClient or DynamicTClient when all the
 * Tapestry integration steps are done.  It's a replacement for
 * StagesInitializedSignal as the "go ahead" signal for application/test
 * stages.
 */
public class TapestryReadyMsg implements QueueElementIF {

    public SecureHash node_guid;
    public long integrateTime;

    public TapestryReadyMsg (SecureHash n) {
	node_guid = n;
    }

    public TapestryReadyMsg (SecureHash n, long time) {
	node_guid = n;
	integrateTime = time;
    }

    /** Specified by java.lang.Object */
    public String toString()
    {
	String str = new String();

	str += "<TapestryReadyMsg";
	str += " node_guid=" + node_guid;
	str += " integrateTime=" + integrateTime + " ms";
	str += ">";
	
	return str;
    }
}
