/**
 * TapestryPublishMsgChannel.
 *
 * @author     Ling Huang
 * @version    $Id: TapestryPublishMsgChannel.java,v 1.2 2002/07/23 22:14:28 hling Exp $
 */
package ostore.tapestry.impl.test;
import ostore.tapestry.api.*;
import ostore.tapestry.channel.*;
import ostore.util.SecureHash;
import ostore.util.OutputBuffer;
import ostore.util.InputBuffer;
import ostore.util.QSException;
import ostore.util.QuickSerializable;
import seda.sandStorm.api.QueueElementIF;

/**
 * Messages sent from one OceanStore machine to any other.  To send a
 * message from one OceanStore machine to any other, one simply inherits
 * from this class, filling in the proper serialization code for the
 * inherited class's data.  (The Tapestry stage will take care of the
 * fields in this class itself.)  
 *
 * <p> Implementation-wise, this is simply a route-to-root operation.
 */
public class TapestryPublishMsgChannel 
extends TapestryPublishMsg implements QuickSerializable
{
    public TapestryPublishMsgChannel (SecureHash guid, TapestryTag tag, int qos) 
    {
	super(guid, tag);
	this.qos = qos;
    }

    public TapestryPublishMsgChannel (InputBuffer buffer) throws QSException
    {
	//	super(buffer);
    }

    public void serialize (OutputBuffer buffer) 
    {
	//	super.serialize (buffer);
    }
    
    public String toString() 
    {
	return "(TapestryPublishMsgChannel from/to="+ guid+ ")";
    }
}



