set title "Route Test with Massive Failure Event"
set xlabel "Time (minutes)"
set ylabel "% Successful Lookups"
set y2label "Mean Latency (ms)"
set xrange [0:15]
set yrange [0:120]
set y2range [0:1000]
set ytics nomirror 0,20 
set ytics 0,10
set y2tics 0,200
set xtics 0,1
set key 13,113
set label '20% of' at 1,90
set label 'nodes fail' at 1,83
set arrow from 3,78 to 5,70 lt 5
set arrow from 5,103 to 5,0 nohead lt 5
set output 'route_test.eps'
set terminal postscript eps color solid 'Helvetica' 20
plot 'results.dat' using (($1+($2-$1)/2)/1000/60):($5*100)\
     title 'Tapestry % Successful' with lines, \
     'results.dat' using (($1+($2-$1)/2)/1000/60):($4*100)\
     title 'Tapestry % Consistent' with lines, \
     'results.dat' using (($1+($2-$1)/2)/1000/60):($8) \
     axis x1y2 title 'Tapestry Mean Latency' with lines
