package ostore.tapestry.patchwork;

/** Specifies a CDF in days */
public class DayPDF extends DiskPDF {

    /**
     * How much to divide the month PDF by
     */
    public static final int factor = (int) (7 /*day/wk*/ 
					    * 4.25 /*wk/month*/);

    public static final int pdf_size = (int) (dPDFarray.length*factor);
    public static final int cdf_size = (int) (dCDFarray.length*factor);

    public double getPDFEntry( int n ) {

	// first decide which month bucket to split up
	int month = (int) Math.floor(n/factor);

	return dPDFarray[month]/factor;
    }

    public int getPDFSize() {
	return pdf_size;
    }

    public int getPDFIncrement() {
	return 1000*60*60*24;
    }

    public double getCDFEntry( int n ) {

	// first decide which month bucket to split up
	int month = (int) Math.floor(n/factor);
	// then fiure out the difference in seconds
	long diff = n - month*factor;
	return dCDFarray[month] + (month<dPDFarray.length?diff*dPDFarray[month]/factor:0.0);
    }

    public int getCDFSize() {
	return cdf_size;
    }

    public int getCDFIncrement() {
	return 1000*60*60*24;
    }

}

