#!/usr/bin/perl -w
#
# $Id: call_remote.pl,v 1.3 2002/11/09 00:05:20 geels Exp $

use strict;
use Getopt::Long;
$Getopt::Long::order = $REQUIRE_ORDER;	# Stop processing at user command.

my %options;
&GetOptions( \%options, "help|?", "parallel|j:i" )
    or &usage() and exit( -1 );

if( $options{"help"} ) {
    &usage() and exit( 0 );
}

# Rest goes into command string
my @command_string = @ARGV;
if( ! @command_string ) {
    &usage() and exit( -1 );
}

sub usage {
    print "\nUSAGE:\t call_remote.pl [--parallel [<max>]] <command> [<args>]\n\n";
}

my @iterator_args = ("--mode", "ssh");
if( defined $options{"parallel"} ) {
    my $num_parallel = ($options{"parallel"} or 10);
    push @iterator_args, ("--parallel", $num_parallel);
}
push @iterator_args, ("call_remote", @command_string);

exec( "./call_iterator.pl", @iterator_args );
